﻿var FWEditor = (function() {
	var version = "0.10";
	var lastupdate = "2017/09/27";
	var idcount = 0;
	var Sqsize = 16;
	var Maxwidth = 100;
	var Maxheight = 100;
	var Defaultwidth = 20;
	var Defaultheight = 20;

	var Toolpx = 20;
	var Toolpy = 20;

	var Tool_button_height = 30;
	var Toolmode = "Terrain";

	var Tool_terrain_space = 30;
	var Tool_terrain_xnum = 8;
	var Tool_building_margin = 20;
	var Tool_extra_margin = 20;

	var Tool_mode_height = 25;
	var Tool_mode_fontsize = 12;

	var Tool_country_height = 40;

	var Mode = [
		{ name: "Terrain", width: 50 },
		{ name: "Extra", width: 50 },
		{ name: "Unit", width: 50 },
//		{ name: "Map", width: 50 },
	];

	var Toolwidth = Toolpx * 2 + Tool_terrain_space * (Tool_terrain_xnum - 1) + Sqsize;
	var Toolheight = Tool_button_height + Tool_mode_height;

	var Tool_select_rectsize = Sqsize + 8;
	var Tool_select_rectcolor = "gray";
	var Tool_select = 0;
	var Tool_country_select = 0;
	var Tool_unit_lock = true;

	var tx, ty;

	var mx, my;
	var dragx = 0;
	var dragy = 0;

	function getmyid() {
		idcount++;
		return idcount;
	}

	function Rect(x, y, w, h) {
		this.x = +x || 0;
		this.y = +y || 0;
		this.w = +w || 10;
		this.h = +h || 10;
	}
	Rect.prototype.isinside = function(x, y) {
		x = +x || 0;
		y = +y || 0;
		if (this.x <= x && x < this.x + this.w && this.y <= y && y < this.y + this.h) {
			return true;
		}
		else {
			return false;
		}
	}

	var Button = [
		{ fname: "new" },
		{ fname: "open" },
		{ fname: "save" },
	];

	var Terrain = [
		{	fname:	"plain",      def: 1, land: true, receiveshadow: true, imgdata: { num: 0, ix: 1, iy : 0, sx: 3, sy: 1, height: 16 } },
		{	fname:	"plain_pd",   def: 1, land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 4, iy : 0, height: 16 } },
		{	fname:	"wood",       def: 2, land: true, shadow: true, imgdata: { num: 1, ix: 0, iy : 0, height: 32 } },
		{	fname:	"mountain",   def: 3, land: true, shadow: true, imgdata: { num: 1, ix: 2, iy : 0, height: 32 } },
		{	fname:	"road",       def: 0, land: true, connect: true, receiveshadow: true, imgdata: { num: 0, ix: 7, iy : 3, height: 16 } },
		{	fname:	"bridge",     def: 0, connect: true, imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		{	fname:	"pipe",       def: 0, land: true, pipe: true, connect: true, imgdata: { num: 0, ix: 3, iy : 11, height: 16 } },
		{	fname:	"pipe_c",     def: 0, land: true, pipe: true, connect: true, candestroy: true, hp: 99, imgdata: { num: 1, ix: 2, iy : 3, height: 16 } },
		{	fname:	"river",      def: 0, land: true, connect: true, imgdata: { num: 0, ix: 25, iy : 0, height: 16 } },
		{	fname:	"sea",        def: 0, sea: true, connect: true, imgdata: { num: 0, ix: 12, iy : 1, height: 16 } },
		{	fname:	"reef",       def: 1, sea: true, imgdata: { num: 1, ix: 4, iy : 3, height: 16 } },
		{	fname:	"shoal",      def: 0, sea: true, connect: true, imgdata: { num: 0, ix: 10, iy : 8, height: 16 } },
		{	fname:	"missle",     def: 0, land: true, shadow: true, imgdata: { num: 1, ix: 4, iy : 0, height: 32 } },
		{	fname:	"misslenone", def: 0, land: true, shadow: true, imgdata: { num: 1, ix: 9, iy : 3, height: 16 }, space: 1 },
		{	fname:	"wideriver",  def: 0, land: true, connect: true, imgdata: { num: 0, ix: 1, iy : 1, height: 16 } },
	];

	var Building = [
		{	fname:	"hq", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
		{	fname:	"city", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"base", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"airport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"seaport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"comtower", def: 3, land: true, building: true, shadow: true },
		{	fname:	"rlab", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
	]

	var Extra = [
		{	fname:	"road10", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  7, iy : 3, sx: 11, sy: 5, height: 16 } },
		{	fname:	"road5",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  4, iy : 2, sx:  8, sy: 4, height: 16 } },
		{	fname:	"road3",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 3, sx: 10, sy: 5, height: 16 } },
		{	fname:	"road6",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  5, iy : 2, sx:  9, sy: 4, height: 16 } },
		{	fname:	"road12", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  6, iy : 2, sx: 10, sy: 4, height: 16 } },
		{	fname:	"road9",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix:  8, iy : 3, sx: 12, sy: 5, height: 16 } },
		{	fname:	"road7",  def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 26, iy : 7, sx: 28, sy: 7, height: 16 } },
		{	fname:	"road14", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 25, iy : 7, sx: 27, sy: 7, height: 16 }, newline: true },
		{	fname:	"road13", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 23, iy : 6, sx: 25, sy: 6, height: 16 } },
		{	fname:	"road11", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 22, iy : 6, sx: 24, sy: 6, height: 16 } },
		{	fname:	"road15", def: 0, land: true, receiveshadow: true, imgdata: { num: 0, ix: 27, iy : 8, sx: 28, sy: 8, height: 16 }, space: 1 },
		{	fname:	"bridgeh", def: 0, imgdata: { num: 0, ix: 21, iy : 0, height: 16 } },
		{	fname:	"bridgev", def: 0, imgdata: { num: 0, ix: 22, iy : 0, height: 16 }, newline: true },
		{	fname:	"river10",  def: 0, land: true, imgdata: { num: 0, ix: 25, iy :  0, height: 16 } },
		{	fname:	"river5",   def: 0, land: true, imgdata: { num: 0, ix: 24, iy :  0, height: 16 } },
		{	fname:	"river19",  def: 0, land: true, imgdata: { num: 0, ix:  2, iy :  4, height: 16 } },
		{	fname:	"river38",  def: 0, land: true, imgdata: { num: 0, ix:  0, iy :  3, height: 16 } },
		{	fname:	"river76",  def: 0, land: true, imgdata: { num: 0, ix:  1, iy :  3, height: 16 } },
		{	fname:	"river137", def: 0, land: true, imgdata: { num: 0, ix:  3, iy :  4, height: 16 } },
		{	fname:	"river55",  def: 0, land: true, imgdata: { num: 0, ix: 19, iy :  7, height: 16 } },
		{	fname:	"river110", def: 0, land: true, imgdata: { num: 0, ix: 22, iy :  9, height: 16 }, newline: true },
		{	fname:	"river205", def: 0, land: true, imgdata: { num: 0, ix: 20, iy :  7, height: 16 } },
		{	fname:	"river155", def: 0, land: true, imgdata: { num: 0, ix: 24, iy : 10, height: 16 } },
		{	fname:	"river255", def: 0, land: true, imgdata: { num: 0, ix: 27, iy :  0, height: 16 }, space: 1 },
		{	fname:	"sea_r1", def: 0, imgdata: { num: 0, ix: 25, iy :  9, height: 16 } },
		{	fname:	"sea_r2", def: 0, imgdata: { num: 0, ix: 26, iy :  9, height: 16 } },
		{	fname:	"sea_r4", def: 0, imgdata: { num: 0, ix: 23, iy :  8, height: 16 } },
		{	fname:	"sea_r8", def: 0, imgdata: { num: 0, ix: 24, iy :  8, height: 16 }, newline: true },
		{	fname:	"pipe10", land: true, pipe: true, imgdata: { num: 0, ix:  3, iy : 11, height: 16 } },
		{	fname:	"pipe5",  land: true, pipe: true, imgdata: { num: 0, ix:  4, iy : 11, height: 16 } },
		{	fname:	"pipe3",  land: true, pipe: true, imgdata: { num: 1, ix:  0, iy :  3, height: 16 } },
		{	fname:	"pipe6",  land: true, pipe: true, imgdata: { num: 0, ix:  1, iy : 11, height: 16 } },
		{	fname:	"pipe12", land: true, pipe: true, imgdata: { num: 0, ix:  2, iy : 11, height: 16 } },
		{	fname:	"pipe9",  land: true, pipe: true, imgdata: { num: 1, ix:  1, iy :  3, height: 16 } },
		{	fname:	"pipe4",  land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  8, height: 16 } },
		{	fname:	"pipe8",  land: true, pipe: true, imgdata: { num: 0, ix:  0, iy : 10, height: 16 }, newline: true  },
		{	fname:	"pipe1",  land: true, pipe: true, imgdata: { num: 0, ix:  0, iy :  9, height: 16 } },
		{	fname:	"pipe2",  land: true, pipe: true, imgdata: { num: 0, ix: 29, iy :  9, height: 16 }, space: 1 },
		{	fname:	"pipe_cv", land: true, pipe: true, imgdata: { num: 1, ix: 3, iy :  3, height: 16 }, candestroy: true, hp: 99 },
		{	fname:	"pipe_ch", land: true, pipe: true, imgdata: { num: 1, ix: 2, iy :  3, height: 16 }, candestroy: true, hp: 99 },
		{	fname:	"plain_pdh", def: 1, land: true, pipe: true, imgdata: { num: 0, ix: 1, iy : 10, height: 16 } },
		{	fname:	"plain_pdv", def: 1, land: true, pipe: true, imgdata: { num: 0, ix: 2, iy : 10, height: 16 }, newline: true },
		{	fname:	"mcannon_u", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 7, iy :  0, height: 32 } },
		{	fname:	"mcannon_r", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 9, iy :  0, height: 32 } },
		{	fname:	"mcannon_d", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 6, iy :  0, height: 32 } },
		{	fname:	"mcannon_l", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 8, iy :  0, height: 32 } },
		{	fname:	"mcannon_all", land: true, candestroy: true, hp: 99, shadow: true, imgdata: { num: 1, ix: 5, iy :  0, height: 32 } },
		{	fname:	"bstone", land: true, candestroy: true, hp: 99, shadow: true, newline: true, imgdata: { num: 1, ix: 10, iy :  0, height: 32 } },
		{	fname:	"bcannon_u", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon_d", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon2", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcrystal", land: true, large: true, size: 3, destroyx: 1, destroyy: 2, newline: true },
		{	fname:	"volcano", land: true, large: true, size: 4 },
		{	fname:	"blackarc", land: true, large: true, size: 4 },
		{	fname:	"blackarc2", sea: true, large: true, size: 4 },
		{	fname:	"largebuilding", land: true, large: true, size: 4 },
		{	fname:	"misslelauncher", land: true, large: true, size: 4 },

		{	fname:	"sea0",   hidden: true, imgdata: { num: 0, ix: 12, iy :  1, height: 16 } },
		{	fname:	"sea1",   hidden: true, imgdata: { num: 0, ix: 14, iy :  2, height: 16 } },
		{	fname:	"sea2",   hidden: true, imgdata: { num: 0, ix: 10, iy :  1, height: 16 } },
		{	fname:	"sea4",   hidden: true, imgdata: { num: 0, ix: 10, iy :  0, height: 16 } },
		{	fname:	"sea8",   hidden: true, imgdata: { num: 0, ix: 14, iy :  1, height: 16 } },
		{	fname:	"sea5",   hidden: true, imgdata: { num: 0, ix: 18, iy :  3, height: 16 } },
		{	fname:	"sea10",  hidden: true, imgdata: { num: 0, ix: 12, iy :  0, height: 16 } },
		{	fname:	"sea3",   hidden: true, imgdata: { num: 0, ix: 13, iy :  2, height: 16 } },
		{	fname:	"sea6",   hidden: true, imgdata: { num: 0, ix: 11, iy :  1, height: 16 } },
		{	fname:	"sea12",  hidden: true, imgdata: { num: 0, ix: 13, iy :  1, height: 16 } },
		{	fname:	"sea9",   hidden: true, imgdata: { num: 0, ix: 15, iy :  2, height: 16 } },
		{	fname:	"sea7",   hidden: true, imgdata: { num: 0, ix: 19, iy :  4, height: 16 } },
		{	fname:	"sea14",  hidden: true, imgdata: { num: 0, ix: 17, iy :  4, height: 16 } },
		{	fname:	"sea13",  hidden: true, imgdata: { num: 0, ix: 16, iy :  3, height: 16 } },
		{	fname:	"sea11",  hidden: true, imgdata: { num: 1, ix:  7, iy :  3, height: 16 } },
		{	fname:	"sea15",  hidden: true, imgdata: { num: 0, ix:  8, iy :  0, height: 16 } },
		{	fname:	"sea16",  hidden: true, imgdata: { num: 0, ix: 12, iy :  2, height: 16 } },
		{	fname:	"sea32",  hidden: true, imgdata: { num: 0, ix:  9, iy :  0, height: 16 } },
		{	fname:	"sea64",  hidden: true, imgdata: { num: 0, ix: 11, iy :  0, height: 16 } },
		{	fname:	"sea128", hidden: true, imgdata: { num: 0, ix: 16, iy :  2, height: 16 } },
		{	fname:	"sea48",  hidden: true, imgdata: { num: 0, ix: 18, iy :  4, height: 16 } },
		{	fname:	"sea80",  hidden: true, imgdata: { num: 0, ix: 13, iy :  0, height: 16 } },
		{	fname:	"sea144", hidden: true, imgdata: { num: 0, ix: 16, iy :  4, height: 16 } },
		{	fname:	"sea96",  hidden: true, imgdata: { num: 1, ix:  8, iy :  3, height: 16 } },
		{	fname:	"sea160", hidden: true, imgdata: { num: 0, ix: 15, iy :  1, height: 16 } },
		{	fname:	"sea192", hidden: true, imgdata: { num: 0, ix: 17, iy :  3, height: 16 } },
		{	fname:	"sea112", hidden: true, imgdata: { num: 1, ix:  5, iy :  3, height: 16 } },
		{	fname:	"sea176", hidden: true, imgdata: { num: 0, ix:  9, iy : 10, height: 16 } },
		{	fname:	"sea208", hidden: true, imgdata: { num: 0, ix: 10, iy : 10, height: 16 } },
		{	fname:	"sea224", hidden: true, imgdata: { num: 1, ix:  6, iy :  3, height: 16 } },
		{	fname:	"sea240", hidden: true, imgdata: { num: 0, ix: 11, iy : 10, height: 16 } },
		{	fname:	"sea33",  hidden: true, imgdata: { num: 0, ix:  3, iy :  8, height: 16 } },
		{	fname:	"sea65",  hidden: true, imgdata: { num: 0, ix:  4, iy :  8, height: 16 } },
		{	fname:	"sea97",  hidden: true, imgdata: { num: 0, ix:  5, iy :  8, height: 16 } },
		{	fname:	"sea66",  hidden: true, imgdata: { num: 0, ix: 19, iy :  5, height: 16 } },
		{	fname:	"sea130", hidden: true, imgdata: { num: 0, ix:  1, iy :  7, height: 16 } },
		{	fname:	"sea194", hidden: true, imgdata: { num: 0, ix: 21, iy :  5, height: 16 } },
		{	fname:	"sea132", hidden: true, imgdata: { num: 0, ix:  6, iy :  9, height: 16 } },
		{	fname:	"sea20",  hidden: true, imgdata: { num: 0, ix:  5, iy :  9, height: 16 } },
		{	fname:	"sea148", hidden: true, imgdata: { num: 0, ix:  7, iy :  9, height: 16 } },
		{	fname:	"sea24",  hidden: true, imgdata: { num: 0, ix:  0, iy :  7, height: 16 } },
		{	fname:	"sea40",  hidden: true, imgdata: { num: 0, ix: 18, iy :  5, height: 16 } },
		{	fname:	"sea56",  hidden: true, imgdata: { num: 0, ix: 20, iy :  5, height: 16 } },
		{	fname:	"sea67",  hidden: true, imgdata: { num: 0, ix:  7, iy :  8, height: 16 } },
		{	fname:	"sea134", hidden: true, imgdata: { num: 0, ix:  9, iy :  9, height: 16 } },
		{	fname:	"sea28",  hidden: true, imgdata: { num: 0, ix:  8, iy :  9, height: 16 } },
		{	fname:	"sea41",  hidden: true, imgdata: { num: 0, ix:  6, iy :  8, height: 16 } },

		{	fname:	"shoal1",   hidden: true, imgdata: { num: 0, ix: 10, iy :  8, height: 16 } },
		{	fname:	"shoal17",  hidden: true, imgdata: { num: 0, ix:  5, iy :  7, height: 16 } },
		{	fname:	"shoal129", hidden: true, imgdata: { num: 0, ix:  6, iy :  7, height: 16 } },
		{	fname:	"shoal145", hidden: true, imgdata: { num: 0, ix: 20, iy :  2, height: 16 } },
		{	fname:	"shoal2",   hidden: true, imgdata: { num: 0, ix: 26, iy :  4, height: 16 } },
		{	fname:	"shoal34",  hidden: true, imgdata: { num: 0, ix: 25, iy :  5, height: 16 } },
		{	fname:	"shoal18",  hidden: true, imgdata: { num: 0, ix:  7, iy :  7, height: 16 } },
		{	fname:	"shoal50",  hidden: true, imgdata: { num: 0, ix: 16, iy :  1, height: 16 } },
		{	fname:	"shoal4",   hidden: true, imgdata: { num: 0, ix: 23, iy :  4, height: 16 } },
		{	fname:	"shoal68",  hidden: true, imgdata: { num: 0, ix: 20, iy :  3, height: 16 } },
		{	fname:	"shoal36",  hidden: true, imgdata: { num: 0, ix: 19, iy :  3, height: 16 } },
		{	fname:	"shoal100", hidden: true, imgdata: { num: 0, ix: 16, iy :  0, height: 16 } },
		{	fname:	"shoal8",   hidden: true, imgdata: { num: 0, ix: 27, iy :  4, height: 16 } },
		{	fname:	"shoal136", hidden: true, imgdata: { num: 0, ix:  8, iy :  7, height: 16 } },
		{	fname:	"shoal72",  hidden: true, imgdata: { num: 0, ix: 26, iy :  5, height: 16 } },
		{	fname:	"shoal200", hidden: true, imgdata: { num: 0, ix: 20, iy :  1, height: 16 } },
		{	fname:	"shoal3",   hidden: true, imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		{	fname:	"shoal35",  hidden: true, imgdata: { num: 0, ix: 28, iy :  5, height: 16 } },
		{	fname:	"shoal131", hidden: true, imgdata: { num: 0, ix: 16, iy :  9, height: 16 } },
		{	fname:	"shoal163", hidden: true, imgdata: { num: 0, ix: 18, iy :  2, height: 16 } },
		{	fname:	"shoal6",   hidden: true, imgdata: { num: 0, ix: 12, iy :  6, height: 16 } },
		{	fname:	"shoal70",  hidden: true, imgdata: { num: 0, ix: 14, iy :  8, height: 16 } },
		{	fname:	"shoal22",  hidden: true, imgdata: { num: 0, ix: 10, iy :  7, height: 16 } },
		{	fname:	"shoal86",  hidden: true, imgdata: { num: 0, ix: 17, iy :  1, height: 16 } },
		{	fname:	"shoal12",  hidden: true, imgdata: { num: 0, ix: 13, iy :  6, height: 16 } },
		{	fname:	"shoal140", hidden: true, imgdata: { num: 0, ix: 11, iy :  7, height: 16 } },
		{	fname:	"shoal44",  hidden: true, imgdata: { num: 0, ix: 13, iy :  8, height: 16 } },
		{	fname:	"shoal172", hidden: true, imgdata: { num: 0, ix: 19, iy :  1, height: 16 } },
		{	fname:	"shoal9",   hidden: true, imgdata: { num: 0, ix: 16, iy :  7, height: 16 } },
		{	fname:	"shoal25",  hidden: true, imgdata: { num: 0, ix: 15, iy :  9, height: 16 } },
		{	fname:	"shoal73",  hidden: true, imgdata: { num: 0, ix: 29, iy :  5, height: 16 } },
		{	fname:	"shoal89",  hidden: true, imgdata: { num: 0, ix: 21, iy :  2, height: 16 } },
		{	fname:	"shoal7",   hidden: true, imgdata: { num: 0, ix: 24, iy :  2, height: 16 } },
		{	fname:	"shoal14",  hidden: true, imgdata: { num: 0, ix: 25, iy :  2, height: 16 } },
		{	fname:	"shoal13",  hidden: true, imgdata: { num: 0, ix: 23, iy :  2, height: 16 } },
		{	fname:	"shoal11",  hidden: true, imgdata: { num: 0, ix: 27, iy :  3, height: 16 } },

		{	fname:	"river3",   hidden: true, land: true, imgdata: { num: 0, ix:  6, iy :  6, height: 16 } },
		{	fname:	"river6",   hidden: true, land: true, imgdata: { num: 0, ix:  4, iy :  5, height: 16 } },
		{	fname:	"river12",  hidden: true, land: true, imgdata: { num: 0, ix:  5, iy :  5, height: 16 } },
		{	fname:	"river9",   hidden: true, land: true, imgdata: { num: 0, ix:  7, iy :  6, height: 16 } },
		{	fname:	"river7",   hidden: true, land: true, imgdata: { num: 0, ix:  4, iy :  3, height: 16 } },
		{	fname:	"river23",  hidden: true, land: true, imgdata: { num: 0, ix:  8, iy :  5, height: 16 } },
		{	fname:	"river39",  hidden: true, land: true, imgdata: { num: 0, ix:  6, iy :  4, height: 16 } },
		{	fname:	"river14",  hidden: true, land: true, imgdata: { num: 0, ix:  0, iy :  2, height: 16 } },
		{	fname:	"river46",  hidden: true, land: true, imgdata: { num: 0, ix: 20, iy :  6, height: 16 } },
		{	fname:	"river78",  hidden: true, land: true, imgdata: { num: 0, ix: 21, iy :  6, height: 16 } },
		{	fname:	"river13",  hidden: true, land: true, imgdata: { num: 0, ix:  5, iy :  3, height: 16 } },
		{	fname:	"river77",  hidden: true, land: true, imgdata: { num: 0, ix:  7, iy :  4, height: 16 } },
		{	fname:	"river141", hidden: true, land: true, imgdata: { num: 0, ix:  9, iy :  5, height: 16 } },
		{	fname:	"river11",  hidden: true, land: true, imgdata: { num: 0, ix:  1, iy :  2, height: 16 } },
		{	fname:	"river139", hidden: true, land: true, imgdata: { num: 0, ix: 24, iy :  7, height: 16 } },
		{	fname:	"river27",  hidden: true, land: true, imgdata: { num: 0, ix: 23, iy :  7, height: 16 } },
		{	fname:	"river15",  hidden: true, land: true, imgdata: { num: 0, ix:  1, iy :  1, height: 16 } },
	]

	var Country = [ 
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
		{ fname: "no", npc: true },
	];

	var Country_indextable = [];
	for (var i = 0 ; i < Country.length ; i++) {
		var c = Country[i];
		Country_indextable[c.fname] = i;
		if (c.npc) {
			continue;
		}
		c.image = [];
		c.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Sqsize, Sqsize);
		c.image = new Image();
		c.image.src = "image/button/" + c.fname + ".png";
	}

	var lockbutton = {};
  lockbutton.toolrect = new Rect(Toolpx + 6 * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy, Sqsize, Sqsize);
	lockbutton.image = [];
	lockbutton.image[0] = new Image();
	lockbutton.image[0].src = "image/button/lock.png";
	lockbutton.image[1] = new Image();
	lockbutton.image[1].src = "image/button/unlock.png";

	var Terrain_indextable = {};
	var Maptype = [
		{ fname: "normal" },
	];

	var left = 0;
	for (var b of Button) {
		b.img = new Image();
		b.img.src = "image/button/" + b.fname + ".png";
		b.rect = new Rect(left, 0, Tool_button_height, Tool_button_height);
		left += Tool_button_height;
	}

	left = 0;
	for (var m of Mode) {
		m.rect = new Rect(left, Tool_button_height, m.width, Tool_mode_height);
		left += m.width;
	}

	var terrainimg = [];
	for (var i = 0 ; i < 2 ; i++) {
		terrainimg[i] = [];
		for (var k = 0 ; k < Maptype.length ; k++) {
			terrainimg[i][k] = new Image();
 			terrainimg[i][k].src = "image/terrain/" + Maptype[k].fname + "/images" + i + ".png";
		}
	}
	
	var lx = 0;
	var ly = 0;
	for (var i = 0 ; i < Terrain.length ; i++) {
		var t = Terrain[i];
		Terrain_indextable[t.fname] = i;
		t.image = [];
		t.cimage = [];
		t.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Toolheight + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
		for (var j = 0 ; j < Maptype.length ; j++) {
			t.image[j] = new Image();
		  t.image[j].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			if (t.connect) {
				t.cimage[j] = [];
				for (var k = 0 ; k < 16 + ((t.fname == "sea") ? 8 : 0) + ((t.fname == "shoal") ? 24 : 0) ; k++) {
					t.cimage[j][k] = new Image();
				  t.cimage[j][k].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + k + ".png";
				}
			}
			if (t.fname == "plain_pd" || t.fname == "pipe_c" || t.fname == "bridge") {
				t.cimage[j] = [];
				t.cimage[j][0] = new Image();
			  t.cimage[j][0].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "h.png";
				t.cimage[j][1] = new Image();
			  t.cimage[j][1].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "v.png";
			}
			if (t.fname == "plain_pd") {
				t.cimage[j][2] = new Image();
			  t.cimage[j][2].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			}
		}
		lx++;
		if (t.space) {
			lx += t.space;
		}
		if (lx >= Tool_terrain_xnum) {
			lx = 0;
			ly++;
		}
	}
	Toolheight += Toolpy + 2 * Tool_terrain_space + Tool_building_margin;
	for (var j = 0 ; j < Country.length ; j++) {
		for (var i = 0 ; i < Building.length ; i++) {
			var b = Building[i];
			if (b.hq == true && Country[j].npc) {
				continue;
			}
			var t = Terrain[Terrain.length] = {};
			t.image = [];
			var bkeys = Object.keys(b);
			for (var key in bkeys) {
				t[bkeys[key]] = b[bkeys[key]];
			}
			t.country = Country[j].fname;
			t.countryid = j;
			t.toolrect = new Rect(Toolpx + i * Tool_terrain_space, Toolheight + j * Tool_terrain_space, Sqsize, Sqsize);
			for (var k = 0 ; k < Maptype.length ; k++) {
				t.fname += "_" + Country[j].fname
				Terrain_indextable[t.fname] = Terrain.length - 1;
				t.image[k] = new Image();
		  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
			}
		}
	}
	var Extratoolindex = Terrain.length;
	var lx = 0;
	var ly = 0;
	for (var i = 0 ; i < Extra.length ; i++) {
		var e = Extra[i];
		var t = Terrain[Terrain.length] = {};
		var ekeys = Object.keys(e);
		for (var key of ekeys) {
			t[key] = e[key];
		}
		t.extra = true;
		t.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Tool_button_height + Tool_mode_height + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
		t.image = [];
		Terrain_indextable[t.fname] = Terrain.length - 1;
		for (var k = 0 ; k < Maptype.length ; k++) {
			t.image[k] = new Image();
	  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
		}
		if (t.large == true) {
			for (var y = 0 ; y < t.size ; y++) {
				for (var x = 0 ; x < t.size ; x++) {
					var t2 = Terrain[Terrain.length] = {};
					t2.image = [];
					for (var key of ekeys) {
						t2[key] = t[key];
					}
					t2.x = x;
					t2.y = y;
					t2.hidden = true;
					if (x === t2.destroyx && y === t2.destroyy) {
						t2.candestroy = true;
						t2.hp = 99;
					}
					for (var k = 0 ; k < Maptype.length ; k++) {
						t2.fname += x + "" + y;
						Terrain_indextable[t2.fname] = Terrain.length - 1;
						t2.image[k] = t.image[k];
					}
				}
			}
		}
		lx++;
		if (e.space) {
			lx += e.space;
		}
		if (e.newline || lx >= Tool_terrain_xnum) {
			lx = 0;
			ly++;
		}
	}
	Toolheight = Tool_button_height + Tool_mode_height + 9 * Tool_terrain_space + Toolpy;

	var UnitList = [
		{	fname:	"infantry" },
		{	fname:	"mech" },
		{	fname:	"apc" },
		{	fname:	"oozium", space: 1 },
		{	fname:	"delete", deletebutton: true, newline: true },
		{	fname:	"recon" },
		{	fname:	"tank" },
		{	fname:	"mdtank" },
		{	fname:	"neotank" },
		{	fname:	"megatank" },
		{	fname:	"antiair", newline: true },
		{	fname:	"artillery" },
		{	fname:	"rocket" },
		{	fname:	"missle" },
		{	fname:	"piperunner", newline: true },
		{	fname:	"tcopter" },
		{	fname:	"bcopter" },
		{	fname:	"fighter" },
		{	fname:	"bomber" },
		{	fname:	"stealth" },
		{	fname:	"blackbomb", newline: true },
		{	fname:	"blackboat" },
		{	fname:	"lander" },
		{	fname:	"cruiser" },
		{	fname:	"battleship" },
		{	fname:	"carrier" },
		{	fname:	"sub" },
	]

	var Unit_indextable = [];
	var Unit = [];
	for (var j = 0 ; j < Country.length ; j++) {
		var c = Country[j];
		if (c.npc) {
			continue;
		}
		var lx = 0;
		var ly = 0;
		for (var i = 0 ; i < UnitList.length ; i++) {
			var ul = UnitList[i];
			var index = Unit.length;
			var u = Unit[Unit.length] = {};
			var ekeys = Object.keys(ul);
			for (var key of ekeys) {
				u[key] = ul[key];
			}
			u.uname = u.fname;
			u.fname += "_" + c.fname;
			u.country = c.fname;
			Unit_indextable[u.fname] = index;
			u.image = [];
			u.toolrect = new Rect(Toolpx + lx * Tool_terrain_space, Tool_button_height + Tool_mode_height + Tool_country_height + Toolpy + ly * Tool_terrain_space, Sqsize, Sqsize);
			u.image = new Image();
			if (u.deletebutton) {
			  u.image.src = "image/button/" + u.uname + ".png";
			}
			else {
			  u.image.src = "image/unit/" + u.fname + ".png";
			}
			lx++;
			if (u.space) {
				lx += u.space;
			}
			if (lx >= Tool_terrain_xnum || u.newline) {
				lx = 0;
				ly++;
			}
		}
	}

	function FWEditor(canvasid) {
		var id = getmyid();

		var canvas;
		var ctx;
		var canuse;
		var map, mapbeforedrag;
		var unitdata;
		var unitmap;

		canvas = document.getElementById(canvasid);
		if (!canvas || !canvas.getContext) {
			canuse = false;
			return;
 		}
		canuse = true;
		ctx = canvas.getContext('2d');

		canvas.onmousemove = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			if (usetool) {
				var cx = Math.floor(mx / Sqsize);
				var cy = Math.floor(my / Sqsize);
				if (Toolmode == "Terrain" || Toolmode == "Extra") {
					if (evt.buttons & 1) {
						me.setmap(cx, cy, Tool_select);
					}
					else if (evt.buttons & 2) {
						var fromx = (cx < dragx) ? cx : dragx;
						var fromy = (cy < dragy) ? cy : dragy;
						var tox = (cx > dragx) ? cx : dragx;
						var toy = (cy > dragy) ? cy : dragy;
						var data = me.getdatafromtoolmode();
						var plus = (data[Tool_select].large) ? data[Tool_select].size : 1;
						me.restoremap();
						for (var x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (var y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, Tool_select);
							}
						}
					}
				}
				else if (Toolmode == "Unit") {
					if (evt.buttons & 1) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false && (Unit[Tool_select].deletebutton || Tool_unit_lock === false)) {
							me.deleteunit(selunit.country, selunit.index);
						}
						if (!Unit[Tool_select].deletebutton && me.findunit(cx, cy) === false) {
							me.setunit(cx, cy, Tool_select);
						}
						me.setunitmap();
					}
					else if (evt.buttons & 2) {
						var selunit = me.findunit(cx, cy);
						if (selunit !== false) {
							me.deleteunit(selunit.country, selunit.index);
						}
						me.setunitmap();
					}
				}
			}
			me.draw();
		}
		canvas.onmousedown = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			if (evt.buttons & 2) {
				me.backupmap();
				dragx = Math.floor(mx / Sqsize);;
				dragy = Math.floor(my / Sqsize);;
			}
			if (usetool) {
				this.onmousemove(evt);
				for (var b of Button) {
					if (b.rect.isinside(mx - tx, my - ty)) {
						if (b.fname == "new") {
							me.init();
							me.draw();
						}
						else if (b.fname == "open") {
							var input = document.createElement("input");
							input.type = "file"
							input.onchange = function(e) {
								if (this.files.length > 0){
									var f = this.files[0];
									var reader = new FileReader();
									reader.onload = (function(file) {
										var loaddata = JSON.parse(file.target.result);
										if (loaddata && loaddata.fwmapdataver) {
											width = loaddata.width;
											height = loaddata.height;
											me.init();
											map = [];
											for (var x = 0 ; x < width ; x++) {
												map[x] = [];
												for (var y = 0 ; y < height ; y++) {
													if (Terrain_indextable[loaddata.map[x][y]] === undefined) {
														map[x][y] = Terrain_indextable["plain"];
													}
													else {
														map[x][y] = Terrain_indextable[loaddata.map[x][y]];
													}
												}
											}
											if (loaddata.unitdata !== undefined) {
												unitdata = loaddata.unitdata;
											}
											me.setunitmap();
											me.draw();
										}
										else {
											alert("ファイルの形式が違います");
										}
									});
									reader.readAsText(f);	
								}
							}
							input.click();
						}
						else if (b.fname == "save") {
							var savedata = {
								fwmapdataver:	1,	
								width: 				width,
								height:				height,
							};
							savedata.map = [];
							for (var x = 0 ; x < width ; x++) {
								savedata.map[x] = [];
								for (var y = 0 ; y < height ; y++) {
									savedata.map[x][y] = Terrain[map[x][y]].fname;
								}
							}
							savedata.unitdata = unitdata;
							var blob = new Blob([JSON.stringify(savedata, null, ' ')], {type: "application/json"});
							var a = document.createElement("a");
							a.href = URL.createObjectURL(blob);
							document.body.appendChild(a);
							a.target = "_blank";
							a.download = "save.json";
							a.click();
							document.body.removeChild(a);
						}
						break;
					}
				}
				for (var m of Mode) {
					if (m.rect.isinside(mx - tx, my - ty)) {
						Toolmode = m.name;
						Tool_select = 0;
						if (Toolmode == "Extra") {
							Tool_select = Extratoolindex;
						}
						Tool_country_select = 0;
						break;
					}
				}
				if (Toolmode == "Unit") {
					if (lockbutton.toolrect.isinside(mx - tx, my - ty)) {
						Tool_unit_lock = !Tool_unit_lock;
					}
					for (var i = 0 ; i < Country.length ; i++) {
						var c = Country[i];
						if (c.npc) {
							continue;
						}
						if (c.toolrect.isinside(mx - tx, my - ty)) {
							Tool_country_select = i;
							for (var j = 0 ; j < Unit.length ; j++) {
								if (Unit[Tool_select].uname == Unit[j].uname && Country[i].fname == Unit[j].country) {
									Tool_select = j;
									break;
								}
							}
							break;
						}
					}
				}
				var data = me.getdatafromtoolmode();
				for (var i = 0 ; i < data.length ; i++) {
					var t = data[i];
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					if (t.hidden != true && t.toolrect.isinside(mx - tx, my - ty)) {
						Tool_select = i;
						break;
					}
				}
			}
			me.draw();
		}
		canvas.onmouseup = function(evt) {
			var rect = canvas.getBoundingClientRect();
			mx = Math.floor(evt.clientX - rect.left);
			my = Math.floor(evt.clientY - rect.top);
			me.draw();
		}
		canvas.addEventListener('DOMMouseScroll', mouseWheelEvent);
		canvas.onmousewheel = function(evt) {
			mouseWheelEvent(evt);
		}
		function mouseWheelEvent(evt) {
			var delta = evt.wheelDelta ? evt.wheelDelta : evt.detail;
			var data = me.getdatafromtoolmode();
			if (delta > 0) {
				while (1) {
					Tool_select++;
					if (data.length <= Tool_select) {
						Tool_select = 0;
						break;
					}
					var t = data[Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			else {
				while (1) {
					Tool_select--;
					if (Tool_select < 0) {
						Tool_select = data.length - 1;
					}
					var t = data[Tool_select];
					if (t.x !== undefined) {
						continue;
					}
					if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
						continue;
					}
					if (Toolmode == "Unit" && t.country != Country[Tool_country_select].fname) {
						continue;
					}
					break;
				}
			}
			me.draw();
		}
		canvas.onmouseout = function(evt) {
			dragflag = false;
		}
		canvas.oncontextmenu = function(evt) {
			return false;
		}
	
		var width;
		var height;
		var maptype = 0;

		var usetool = true;

		var me = this;
		
		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: width, height: height }
		};
		this.setsize = function(w, h) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			width = w;
			height = h;
			map = [];
			mapbeforedrag = [];
			for (var x = 0 ; x < width ; x++) {
				map[x] = [];
				for (var y = 0 ; y < height ; y++) {
					map[x][y] = 0;
				}
			}
		}

		this.canuse = function() {
			return canuse;
		}

		this.getdatafromtoolmode = function() {
			if (Toolmode == "Terrain" || Toolmode == "Extra") {
				return Terrain;
			}
			else {
				return Unit;
			}
		}

		this.findunit = function(x, y) {
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				for (var j = 0 ; j < unitdata[c.fname].length ; j++) {
					var u = unitdata[c.fname][j];
					if (u.x == x && u.y == y) {
						return { country: c.fname, index: j };
					}
				}
			}
			return false;
		}

		this.setunit = function(x, y, tid, check) {
			if (this.isinside(x, y)) {
				var c = Unit[tid].country;
				unitdata[c].push({ x: x, y: y, fname: Unit[tid].fname });
			}
		}	

		this.deleteunit = function(cname, index) {
			if (!unitdata[cname]) {
				return;
			}
			unitdata[cname].splice(index, 1);
		}

		this.setunitmap = function() {
			unitmap = [];
			for (var x = 0 ; x < width ; x++) {
				unitmap[x] = [];
				for (var y = 0 ; y < height ; y++) {
					unitmap[x][y] = null;
				}
			}
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				for (var j = 0 ; j < unitdata[c.fname].length ; j++) {
					var u = unitdata[c.fname][j];
					unitmap[u.x][u.y] = u.fname;
				}
			}
		}

		this.drawterrain = function(t, dx, dy, x, y, c, img) {
			if (t.land) {
				ctx.drawImage(Terrain[Terrain_indextable["plain"]].image[maptype], dx, dy);
			}
			if (t.large) {
				ctx.drawImage(img, t.x * Sqsize, t.y * Sqsize, Sqsize, Sqsize, dx, dy, Sqsize, Sqsize);
			}
			else {
				if (t.imgdata) {
					var t2;
					if (t.connect && c !== null) {
						if (t.fname == "wideriver") {
							t2 = Terrain[Terrain_indextable["river" + c]];
						}
						else {
							t2 = Terrain[Terrain_indextable[t.fname + c]];
						}
					}
					else {
						t2 = t;
					}
					if (x > 0 && t2.receiveshadow && Terrain[map[x - 1][y]].shadow) {
						ctx.drawImage(terrainimg[t2.imgdata.num][maptype], t2.imgdata.sx * Sqsize, t2.imgdata.sy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
					}
					else {
						ctx.drawImage(terrainimg[t2.imgdata.num][maptype], t2.imgdata.ix * Sqsize, t2.imgdata.iy * Sqsize, Sqsize, t2.imgdata.height, dx, dy + Sqsize - t2.imgdata.height, Sqsize, t2.imgdata.height);
					}
				}
				else {
					ctx.drawImage(img, dx, dy + Sqsize - img.height);
				}
			}
		}

		this.drawmap = function() {
			for (var y = 0 ; y < height ; y++) {
				for (var x = 0 ; x < width ; x++) {
					var t = Terrain[map[x][y]];
					var img;
					if (t.connect) {
						var c = 0;
						var count = 0;
						var dx = [ 0, 1, 0, -1 ];
						var dy = [ -1, 0, 1, 0 ];
						var di = [ 1, 3, 0, 2 ];
						var isshoal = [];
						for (var i = 0 ; i < 4 ; i++) {
							var x2 = x + dx[di[i]];
							var y2 = y + dy[di[i]];
							isshoal[di[i]] = false;
							if (this.isinside(x2, y2)) {
								var t2 = Terrain[map[x2][y2]];
								if (t2.fname == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((t.fname == "road" && t2.fname == "road") || 
										(t.fname == "bridge" && (t2.fname == "bridge" || t2.land != true)) ||
										(t.fname == "river" && t2.fname == "river") ||
										(t.fname == "wideriver" && (t2.fname == "wideriver" || t2.sea)) ||
										(t.fname == "sea" && t2.land == true) ||
										(t.fname == "shoal" && t2.land == true && (t2.fname != "river" && t2.fname != "wideriver")) ||
										(t.pipe == true && t2.pipe == true && !(t.fname == "plain_pd" && t2.fname == "plain_pd"))) {
									if (i >= 4) {
										if (t.fname == "river") {
											if (c & (1 << (i % 4)) || c & (1 << (i + 1) % 4)) {
												continue;
											}
										}
									}
									c += (1 << di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (t.fname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = "h";
									}
									else if (c == 5) {
										c = "v";
									}
									else if (t.fname == "pipe_c") {
										map[x][y] = Terrain_indextable["pipe"];
										t = Terrain[Terrain_indextable["pipe"]];
									}
									else if (t.fname == "plain_pd") {
										c = "";
									}
									break;
								}
							}
						}
						if (count == 0 && t.fname == "pipe") {
							c = 10;
						}
						if (count <= 1 && t.fname == "road") {
							if (c == 1 || c == 4) {
								c = 5;
							}
							else {
								c = 10;
							}
						}
						if (t.fname == "river" || t.fname == "wideriver" || t.fname == "sea") {
							if (t.fname == "river" || t.fname == "wideriver") {
								if (c == 0) {
									c = 10;
								}
								else if (count == 1) {
									if (c == 1 || c == 4) {
										c = 5;
									}
									else {
										c = 10;
									}
								}
							}
							if (!((t.fname == "river" || t.fname == "wideriver") && (c == 5 || c == 10))) {
								var dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
								var dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
								var island = [];
								var isriver = [];
								var issameriver = [];
								var ismouthriver = [];
								var issea = [];
								for (var i = 0 ; i < 8 ; i++) {
									var x2 = x + dx[i];
									var y2 = y + dy[i];
									island[i] = isriver[i] = issameriver[i] = ismouthriver[i] = issea[i] = false;
									if (this.isinside(x2, y2)) {
										var t2 = Terrain[map[x2][y2]];
										if (t2.land == true) {
											island[i] = true;
										}
										if (t2.sea == true) {
											issea[i] = true;
										}
										if ((t2.fname == "river" || t2.fname == "wideriver") && (t.fname == "sea" || t.fname == t2.fname)) {
											if (t2.fname == "river") {
												isriver[i] = true;
											}
											if (t.fname == t2.fname) {
												issameriver[i] = true;
											}
											if (t2.fname != "wideriver" && (i == 0 || i == 4)) {
												y2 += dy[i];
												if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "river") {
													ismouthriver[i] = true;
												}
											}
											else {
												ismouthriver[i] = true;
											}
										}
									}
								}
								for (var i = 0 ; i < 8 ; i += 2) {
									if (t.fname == "sea" && ismouthriver[i] && (!isriver[i] || (!isriver[(i + 7) % 8] && !isriver[(i + 1) % 8])) && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
										c = "_r" + (1 << (i / 2));
										break;
									}
									if ((t.fname == "sea" && !island[i] && island[(i + 1) % 8] && !island[(i + 2) % 8]) ||
											((t.fname == "river" || t.fname =="wideriver") && issameriver[i] && (!issameriver[(i + 1) % 8] && !(t.fname == "wideriver" && issea[(i + 1) % 8])) && issameriver[(i + 2) % 8])) {
										c |= 1 << ((i / 2) + 4);
									}
								}
							}
						}
						if (count < 2 && t.fname == "pipe_c") {
								map[x][y] = Terrain_indextable["pipe"];
								t = Terrain[Terrain_indextable["pipe"]];
						}
						if (t.fname == "plain_pd" && count != 2) {
								c = "";
						}
						if (t.fname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = "v";
							}
							else {
								c = "h";
							}
						}
						if (t.fname == "wideriver") {
							if (count == 4 && c != 255) {
								c = 15;
							}
						}
						if (t.fname == "shoal") {
							var dx = [ 1, 1, -1, -1 ];
							var dy = [ -1, 1, 1, -1 ];
							var island = [];
							for (var i = 0 ; i < 4 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							var seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (var i = 0 ; i < 4 ; i++) {
								if (c == 1 << i && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = Terrain_indextable["sea"];
								t = Terrain[Terrain_indextable["sea"]];
							}
							else {
								for (var i = 0 ; i < 4 ; i++) {
									if (c == 7 || c == 11 || c == 13 || c == 14) {
										continue;
									}
									if (c & (1 << i)) {
										if (isshoal[(i + 1) % 4] == true) {
											c |= 1 << (i + 4);
										}
										if (isshoal[(i + 3) % 4] == true) {
											c |= 1 << ((i + 3) % 4 + 4);
										}
									}
								}		
							}
						}
						img = t.cimage[maptype][c];
					}
					else {
						img = t.image[maptype];
					}
					this.drawterrain(t, x * Sqsize, y * Sqsize, x, y, c, img);

					var uname = unitmap[x][y];
					if (uname !== null) {
						ctx.drawImage(Unit[Unit_indextable[uname]].image, x * Sqsize, y * Sqsize);
					}
				}
			}
		}

		this.copymap = function(from, to) {
			for (var x = 0 ; x < width ; x++) {
				to[x] = [];
				for (var y = 0 ; y < height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(mapbeforedrag, map);
		}
		this.backupmap = function() {
			this.copymap(map, mapbeforedrag);
		}

		this.drawtool = function() {
			for (var b of Button) {
				ctx.drawImage(b.img, tx + b.rect.x, b.rect.y);
			}
			for (var m of Mode) {
				ctx.beginPath();
				ctx.rect(tx + m.rect.x, ty + m.rect.y + 1, m.rect.w, m.rect.h);
				if (Toolmode != m.name) {
					ctx.fillStyle = "lightgray";
					ctx.fill();
				}
				ctx.strokeStyle = "black";
				ctx.lineWidth = 1;
				ctx.stroke();
				ctx.fillStyle = "black";
				ctx.font = Tool_mode_fontsize + "px sans-serif";
				var twidth = ctx.measureText(m.name).width;
				ctx.fillText(m.name, tx + m.rect.x + (m.rect.w - twidth) / 2, ty + m.rect.y + (m.rect.h + Tool_mode_fontsize) / 2);
			}

			if (Toolmode == "Unit") {
				var c = Country[Tool_country_select];
				ctx.beginPath();
				ctx.fillStyle = Tool_select_rectcolor;
				
				ctx.rect(tx + c.toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + c.toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
				ctx.fill();
				for (var i = 0 ; i < Country.length ; i++) {
					var c = Country[i];
					if (c.npc) {
						continue;
					}
					ctx.drawImage(c.image, tx + c.toolrect.x, ty + c.toolrect.y, Sqsize, Sqsize);
				}
				ctx.drawImage(lockbutton.image[Tool_unit_lock ? 0 : 1], tx + lockbutton.toolrect.x, ty + lockbutton.toolrect.y, Sqsize, Sqsize);
			}

			var data = this.getdatafromtoolmode();

			ctx.beginPath();
			ctx.fillStyle = Tool_select_rectcolor;
			ctx.rect(tx + data[Tool_select].toolrect.x - (Tool_select_rectsize - Sqsize) / 2, ty + data[Tool_select].toolrect.y - (Tool_select_rectsize - Sqsize) / 2, Tool_select_rectsize, Tool_select_rectsize);
			ctx.fill();

			for (var i = 0 ; i < data.length ; i++) {
				var t = data[i];
				if (t.hidden) {
					continue;
				}
				if ((Toolmode == "Terrain" && t.extra) || (Toolmode == "Extra" && !t.extra)) {
					continue;
				}
				if ((Toolmode == "Unit" && t.country != Country[Tool_country_select].fname)) {
					continue;
				}
				if (Toolmode == "Terrain" || Toolmode == "Extra") {

					if (t.large) {
						ctx.drawImage(t.image[maptype], tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
					}
					else {
						this.drawterrain(t, tx + t.toolrect.x, ty + t.toolrect.y, 0, 0, null, t.image[maptype]);
					}
				}
				else {
					ctx.drawImage(t.image, tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
				}
			}
		}

		this.draw = function() {
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, canvas.width, canvas.height);
			ctx.fill();
			this.drawmap();
			if (usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < width && 0 <= y && y < height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetreef = function(x, y) {
			for (var dx = -1 ; dx <= 1 ; dx++) {
				for (var dy = -1 ; dy <= 1 ; dy++) {
					if (dx == 0 && dy == 0) {
						continue;
					}
					var x2 = x + dx;
					var y2 = y + dy;
					if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
						return false;
					}
				}
			}
			return true;
		}

		this.cansetriver = function(x, y) {
			var dx = [ 0, 0, -1, -1 ];
			var dy = [-1, 0, -1, 0 ];
			for (var i = 0 ; i < 4 ; i++) {
				var x2 = x + dx[i];
				var y2 = y + dy[i];
				var allriver = true;
				for (var dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (var dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						var x3 = x2 + dx2;
						var y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || Terrain[map[x3][y3]].fname != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			if (this.isinside(x, y)) {
				for (var dx = -1 ; dx <= 1 ; dx++) {
					for (var dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						var x2 = x + dx;
						var y2 = y + dy;
						if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "reef") {
							map[x2][y2] = Terrain_indextable["sea"];
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tid) {
			var data = this.getdatafromtoolmode();
			var t = data[tid];
			if (this.isinside(x, y)) {
				var t2 = Terrain[map[x][y]];
				if (t2.large == true) {
					for (var dx = 0 ; dx < t2.size ; dx++) {
						for (var dy = 0 ; dy < t2.size ; dy++) {
							var x2 = x - t2.x + dx;
							var y2 = y - t2.y + dy;
							map[x2][y2] = Terrain_indextable["plain"];
							this.deletenearreef(x2, y2);
						}
					}
				}
				map[x][y] = tid;
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.setmap = function(x, y, tid, check) {
			check = check || false;
			retval = false;
			var t = Terrain[tid];
			if (this.isinside(x, y)) {
				if (t.fname == "pipe_c") {
					if (map[x][y] == Terrain_indextable["pipe"] && 
						((this.isinside(x - 1, y) && Terrain[map[x - 1][y]].fname == "pipe" && this.isinside(x + 1, y) && Terrain[map[x + 1][y]].fname == "pipe") ||
						 (this.isinside(x, y - 1) && Terrain[map[x][y - 1]].fname == "pipe" && this.isinside(x, y + 1) && Terrain[map[x][y + 1]].fname == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
					}
				}
				else if (t.fname == "reef") {
					if (Terrain[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
							for (var dx = -1 ; dx <= 1 ; dx++) {
								for (var dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									var x2 = x + dx;
									var y2 = y + dy;
									if (this.isinside(x2, y2) && Terrain[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, Terrain_indextable["sea"]);
									}
								}
							}
						}
					}
				}
				else if (t.fname == "shoal") {
					if (Terrain[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
						}
					}
				}
				else if (t.fname == "river" || t.fname == "wideriver") {
					//if (Terrain[map[x][y]].land == true || Terrain[map[x][y]].pipe == true) {
						if (t.fname == "wideriver" || this.cansetriver(x, y)) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
						}
					//}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					if (!check) {
						for (var x2 = 0; x2 < width ; x2++) {
							for (var y2 = 0 ; y2 < height ; y2++) {
								var t2 = Terrain[map[x2][y2]];
								if (t2.hq == true && t.country == t2.country) {
									this.changemap(x2, y2, Terrain_indextable["plain"]);
								}
							}
						}
						this.changemap(x, y, tid);
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < width && y + t.size - 1 < height) {
						retval = true;
						if (!check) {
							for (var dy = 0 ; dy < t.size ; dy++) {
								for (var dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tid + dy * t.size + dx + 1);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tid);
					}
				}
			}
			return retval;
		}

		this.init = function() {
			canvas.width = Sqsize * width;
			canvas.height = Sqsize * height;
			if (usetool) {
				canvas.width += Toolwidth;
				if (canvas.height < Toolheight) {
					canvas.height = Toolheight;
				}
			}

			unitdata = {};
			for (var i = 0 ; i < Country.length ; i++) {
				var c = Country[i];
				if (c.npc) {
					continue;
				}
				unitdata[c.fname] = [];
			}
			this.setunitmap();

			tx = Sqsize * width;
			ty = 0;

			this.setsize(width, height);
		}

		width = Defaultwidth;
		height = Defaultheight;
		this.init(canvasid);
		this.draw();
	}
	return FWEditor;
}());
